/* 
 *   Creation Date: <2001/06/11 22:41:04 samuel>
 *   Time-stamp: <2002/06/25 12:46:12 samuel>
 *   
 *	<selftest.c>
 *	
 *	This piece of code is run inside MOL. That is, it is
 *	not linked against glibc.
 *   
 *   Copyright (C) 2001, 2002 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#include "mol_config.h"
#include <stdarg.h>
#include "osi_calls.h"

extern void	performance( void );
extern int	entry( void );
extern void	perf_print( char *str, ulong count );


/************************************************************************/
/*	F U N C T I O N S						*/
/************************************************************************/

int
entry( void )
{
	printm("\n ******************************\n"
	         " *    Testing performance     *\n"
	         " ******************************\n\n");

	performance();

	printm("\n ******************************\n"
	         " *    Self-test successful    *\n"
		 " ******************************\n\n");
	return 0;
}

void
perf_print( char *str, ulong count )
{
	static int calibration=0;
	ulong v;
	
	if( !calibration )
		calibration=count;

	v = (ulong)((double)calibration / (double)count * 20000.0 + 0.5);
	printm(" %-19s %3ld.%02ld %%\n", str, v/100, v%100 );
}
